<template>
    <div id="app">
        <router-view/>
    </div>
</template>

<script>

    // (~) is an alias for ./src/components

    // importing Vuex maps
    import { mapActions, mapGetters } from "vuex";

    let every = {
        second      : 1000,
        treeSeconds : 3000,
        minute      : 60000,
        oneHour     : 3600000,
        twoHour     : 7200000,
        fourHour    : 14400000
    };

    export default {
        name: 'app',
        components: {

            // ...

        },
        created() {

            /**
             * .JS Event-listener for detecting when the user
             * leaves, so we can set his/her status to offline
             */
            document.addEventListener('beforeunload', this.handler)

            /*
             *
             */
            this.getEndpoints()

        },
        mounted() {

            // ...

        },
        data() {
            return {

                // ...

            }
        },
        computed: {

            // ...

        },
        methods: {

            ...mapActions({

                fetchEndpoints: 'monitor/fetchEndpoints'

            }),

            getEndpoints() {

                this.fetchEndpoints()

                    .then(() => {

                        console.log("Endpoints stored in state")

                    })

                    .catch(() => {

                        console.log("Endpoints failed")

                    })
            },

            handler: function handler(event) {

                console.log("user left")
            }

        }
    }

</script>

<style lang="scss">

    // ...

</style>
